package solutions.bitbadger.documents.groovy

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.AutoId
import solutions.bitbadger.documents.Configuration
import solutions.bitbadger.documents.Dialect
//import solutions.bitbadger.documents.DocumentException

import static groovy.test.GroovyAssert.*

/**
 * Unit tests for the `Configuration` object
 */
@DisplayName('JVM | Groovy | Configuration')
class ConfigurationTest {

    @Test
    @DisplayName('Default ID field is "id"')
    void defaultIdField() {
        assertEquals('Default ID field incorrect', 'id', Configuration.idField)
    }

    @Test
    @DisplayName('Default Auto ID strategy is DISABLED')
    void defaultAutoId() {
        assertEquals('Default Auto ID strategy should be DISABLED', AutoId.DISABLED, Configuration.autoIdStrategy)
    }

    @Test
    @DisplayName('Default ID string length should be 16')
    void defaultIdStringLength() {
        assertEquals('Default ID string length should be 16', 16, Configuration.idStringLength)
    }

    @Test
    @DisplayName('Dialect is derived from connection string')
    void dialectIsDerived() {
        try {
            // TODO: uncomment once java.base open issue resolved
            //assertThrows(DocumentException) { Configuration.dialect() }
            Configuration.connectionString = 'jdbc:postgresql:db'
            assertEquals(Dialect.POSTGRESQL, Configuration.dialect())
        } finally {
            Configuration.connectionString = null
        }
    }
}
