package solutions.bitbadger.documents.java.jvm.integration.postgresql;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.java.jvm.integration.common.CountFunctions;
import solutions.bitbadger.documents.jvm.integration.postgresql.PgDB;

/**
 * PostgreSQL integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("JVM | Java | PostgreSQL: Count")
public class CountIT {

    @Test
    @DisplayName("all counts all documents")
    public void all() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.all(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    public void byFieldsNumeric() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.byFieldsNumeric(db);
        }
    }

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    public void byFieldsAlpha() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.byFieldsAlpha(db);
        }
    }

    @Test
    @DisplayName("byContains counts documents when matches are found")
    public void byContainsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.byContainsMatch(db);
        }
    }

    @Test
    @DisplayName("byContains counts documents when no matches are found")
    public void byContainsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.byContainsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath counts documents when matches are found")
    public void byJsonPathMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.byJsonPathMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath counts documents when no matches are found")
    public void byJsonPathNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CountFunctions.byJsonPathNoMatch(db);
        }
    }
}
