package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import solutions.bitbadger.documents.{AutoId, Configuration, Dialect, DocumentException}

class ConfigurationSpec extends AnyFunSpec {

  describe("idField") {
    it("defaults to `id`") {
      assert("id" == Configuration.idField)
    }
  }

  describe("autoIdStrategy") {
    it("defaults to `DISABLED`") {
      assert(AutoId.DISABLED == Configuration.autoIdStrategy)
    }
  }

  describe("idStringLength") {
    it("defaults to 16") {
      assert(16 == Configuration.idStringLength)
    }
  }

  describe("dialect") {
    it("is derived from connection string") {
      try {
        assertThrows[DocumentException] { Configuration.dialect() }
        Configuration.setConnectionString("jdbc:postgresql:db")
        assert(Dialect.POSTGRESQL == Configuration.dialect())
      } finally {
        Configuration.setConnectionString(null)
      }
    }
  }
}
