package solutions.bitbadger.documents.scala

import org.scalatest.funspec.AnyFunSpec
import solutions.bitbadger.documents.{Dialect, DocumentException}

class DialectSpec extends AnyFunSpec {

  describe("deriveFromConnectionString") {
    it("derives PostgreSQL correctly") {
      assert(Dialect.POSTGRESQL == Dialect.deriveFromConnectionString("jdbc:postgresql:db"))
    }
    it("derives SQLite correctly") {
      assert(Dialect.SQLITE == Dialect.deriveFromConnectionString("jdbc:sqlite:memory"))
    }
    it("fails when the connection string is unknown") {
      try {
        Dialect.deriveFromConnectionString("SQL Server")
        fail("Dialect derivation should have failed")
      } catch {
        case ex: DocumentException =>
          assert(ex.getMessage != null)
          assert(ex.getMessage.contains("[SQL Server]"))
      }
    }
  }
}
